#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

from baselevel import *

(white, blue) = Gen_Stars(Create_String)


white.Add_Sequence("1")
blue.Add_Sequence("0")

blue = Create_Component(Light_Control, blue)
white = Create_Component(Light_Control, white)
one = Create_Component(Stimulator_Simple, ST_ONE)
zero = Create_Component(Stimulator_Simple, ST_ZERO)


Meta_Data(text = "Christmas is not 'Off' until it's Off",
    desc = "On this level, you should arrange for the white 'shooting star' "
        "lights to shine constantly. Make the blue 'shooting star' lights "
        "stay off by connecting them to the 'Off' supply.\n\n"
        "Hint: In 'Christmas Logic', a light is only 'Off' if it's connected "
        "to something outputting an 'Off' signal! If it's not connected "
        "to a power source, it's 'Undefined'. This seems weird, but it's "
        "really important for the later levels.",
    guide = [
    Guide(trigger = "white.Get_State() == ST_UNDEFINED",
        point_at = "one.Get_Terminal()",
        text = "First, the white stars. "
            "Point the mouse here and hold the left button down."),
    Guide(trigger = "(n.Is_Placing_Wire() and (s == one.Get_Terminal()))",
        point_at = "white.Get_Terminal()",
        text = "You're placing a 'Wire'. Drag the line to the terminal "
            "attached to the white stars."),
    Guide(trigger = "((white.Get_State() == ST_ONE) "
                    "and (blue.Get_State() == ST_UNDEFINED))",
        point_at = "zero.Get_Terminal()",
        text = "Now, the blue stars. You can see that they are 'off' now, "
            "but not fully off, because nothing is connected to them. This "
            "state is called 'Undefined' - neither on, nor off! The rules "
            "of the game say that Undefined is not a substitute for Off. "
            "To fix this, connect the 'Off' supply to the terminal attached "
            "to the blue lights."),
    ])

