#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

from baselevel import *

red = Create_String(String, "red", (255, 0, 0))
red.Add_Sequence("1")

red = Create_Component(Light_Control, red)
clock = Create_Component(Stimulator_Simple, ST_CLOCK)
notgate = Create_Component(Not_Gate)
orgate = Create_Component(Or_Gate)
original = orgate.Get_Location()


Meta_Data(text = "On 'Or' Off",
    image = "tree1",
    desc = "This level is the first proper puzzle! You get only a "
        "flashing input signal, but you have to make the red "
        "lights stay on constantly. To do that, you have to use both "
        "the 'Not' component and the new 'Or' component. 'Or' has two "
        "inputs, and its output is On if either input is On.\n\n"
        "Hint: What happens if you connect the inputs of 'Or' to both "
        "sides of a 'Not' component?",
    guide = [
    Guide(trigger = "True",
        point_at = "orgate",
        requires_ack = True,
        text = "This is the 'Or' component. It has two inputs. The output "
            "is 'On' if one or both of the inputs is 'On'. "
            "If both inputs are 'Off', the output is 'Off' too. "
            "Click 'Next' when you are ready..."),
    Guide(trigger = "not (orgate in clock.provides)",
        point_at = "clock.Get_Terminal()",
        text = "Begin by connecting the flashing signal to one input of the "
            "'Or' component."),
    Guide(trigger = "((orgate in clock.provides) "
                "and not (notgate in clock.provides))",
        point_at = "notgate",
        text = "The output of the 'Or' component is still 'Undefined'. That's "
            "because only one input is connected. The other input should be "
            "connected to the flashing input - via 'Not'. Do that now!"),
    Guide(trigger = "((notgate in clock.provides) "
                "and (orgate in clock.provides) "
                "and (orgate in notgate.provides))",
        point_at = "orgate",
        text = "Notice that the output of the 'Or' component is always on! "
            "Because of how the 'Not' component is wired up, one of the 'Or' "
            "inputs is always On. If one or both of the 'Or' inputs is On, "
            "then the output must also be On! Thus, the flashing signal is "
            "converted to a steady signal. Connect the 'Or' output to the "
            "lights to complete the level."),
    ])

