#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#


def Least_Common_Multiple(integer_list):
    if len(integer_list) == 0:
        return 1

    copy_list = integer_list[:]
    size = len(integer_list)

    # "Table algorithm" from Wikipedia
    # http://en.wikipedia.org/wiki/Least_common_multiple
    div = 2
    lcm = 1
    not_one = True
    while not_one:
        did_divide = not_one = False
        for i in xrange(size):
            if (copy_list[ i ] % div) == 0:
                copy_list[ i ] /= div
                did_divide = True

            if copy_list[ i ] != 1:
                not_one = True
        
        if did_divide:
            lcm *= div
        else:
            # Really we should use prime numbers here
            # but it's ok to use composites too (but slower, 
            # since composites will never divide).
            div += 1

    # Check that this really is a common multiple
    for test in integer_list:
        assert test <= lcm
        assert (lcm % test) == 0
    
    return lcm
    
